from __future__ import division
import math
import numpy as np
import scipy.sparse as sps
import scipy as sp
import os
import re
import urllib
import sys

DIRS = []
DATADIR = '/home/peportier/data/eswc2015/inputs_scale_4'

def mk_dirs():
  global DIRS
  DIRS = []
  for d in os.walk(DATADIR):
    DIRS.append(d[0])
  regex = re.compile(r'^.*/p[0-9]*$')
  DIRS = [d for d in DIRS if regex.search(d)]

def go():
  mk_dirs()
  for d in DIRS:
    print(d)
    f = open(d+'/finput','r')
    str_res_urls = f.readline()
    nb_res = len(str_res_urls.split())
    s='' # string representation of the dense version of the matrix
         # e.g. "0 0; 1 0"
    for i in range(0,nb_res):
      s+=f.readline()
      if i != (nb_res - 1):
        s+='; '
    f.close()
    
    m = np.matrix(s)
    sm = sps.csc_matrix(m)
    
    f = open(d+'/finputsparse','w')
    f.write(str_res_urls)

    # sm.data is: the value of each non-zero entry.
    s=''
    for x in sm.data:
      s+='{} '.format(x)
    s = s[:-1]
    s+="\n"
    f.write(s)
    
    # sm.indices is: for each nz entry, the row index.
    s=''
    for x in sm.indices:
      s+='{} '.format(x)
    s = s[:-1]
    s+="\n"
    f.write(s)

    # sm.indptr is: for each col (plus 1), index of first nz entry.
    # The last value of indptr is by convention the
    # total number of nz entries.
    s=''
    for x in sm.indptr:
      s+='{} '.format(x)
    s = s[:-1]
    s+="\n"
    f.write(s)

    f.close()